• HDU1045:Fire Net(二分图匹配 / DFS)


    Fire Net

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 15653    Accepted Submission(s): 9474

    题目链接acm.hdu.edu.cn/showproblem.php?pid=1045

    Description:

    Suppose that we have a square city with straight streets. A map of a city is a square board with n rows and n columns, each representing a street or a piece of wall.

    A blockhouse is a small castle that has four openings through which to shoot. The four openings are facing North, East, South, and West, respectively. There will be one machine gun shooting through each opening.

    Here we assume that a bullet is so powerful that it can run across any distance and destroy a blockhouse on its way. On the other hand, a wall is so strongly built that can stop the bullets.

    The goal is to place as many blockhouses in a city as possible so that no two can destroy each other. A configuration of blockhouses is legal provided that no two blockhouses are on the same horizontal row or vertical column in a map unless there is at least one wall separating them. In this problem we will consider small square cities (at most 4x4) that contain walls through which bullets cannot run through.

    The following image shows five pictures of the same board. The first picture is the empty board, the second and third pictures show legal configurations, and the fourth and fifth pictures show illegal configurations. For this board, the maximum number of blockhouses in a legal configuration is 5; the second picture shows one way to do it, but there are several other ways.



    Your task is to write a program that, given a description of a map, calculates the maximum number of blockhouses that can be placed in the city in a legal configuration.

    Input:

    The input file contains one or more map descriptions, followed by a line containing the number 0 that signals the end of the file. Each map description begins with a line containing a positive integer n that is the size of the city; n will be at most 4. The next n lines each describe one row of the map, with a '.' indicating an open space and an uppercase 'X' indicating a wall. There are no spaces in the input file.

    Output:

    For each test case, output one line containing the maximum number of blockhouses that can be placed in the city in a legal configuration.

    Sample Input:

    4
    .X..
    ....
    XX..
    ....
    2
    XX
    .X
    3
    .X.
    X.X
    .X.
    3
    ...
    .XX
    .XX
    4
    ....
    ....
    ....
    ....
    0

    Sample Output:

    5
    1
    5
    2
    4

    题意:

    n行n列的棋盘上有一些障碍物,现在要求放置最多的车,如果同一行或同一列有车的话就不能放置,但是中间又障碍物挡住的话就可以放置。

    题解:

    这题可以有两种解法,二分图匹配和dfs,毕竟数据量比较小。

    先说二分图匹配:

    这个博客写的二分图匹配挺好的:https://blog.csdn.net/c20180630/article/details/70175814

    每一行可以作为x集合,每一列可以作为y集合,这样一个点可以由一个x中的数与y中的数相匹配来确定。

    但是这里有障碍物,如果像上面这样想,多行可以连一列或者多列可以连一行。

    正确的做法就是,把那多行分成多个一行,多列分成多个一列,遇到障碍物就分。

    代码如下:

    #include <cstdio>
    #include <cstring>
    #include <algorithm>
    #include <iostream>
    using namespace std;
    
    const int N = 20 ;
    int n,cnt=0,ans=0,tot=0;
    int map1[N][N],map2[N][N],match[N],link[N][N],check[N];
    char tmp[N][N] ;
    
    inline void init(){
        cnt=0;tot=0;ans=0;
        memset(map1,0,sizeof(map1));memset(map2,0,sizeof(map2));
        memset(match,-1,sizeof(match));memset(link,0,sizeof(link));
    }
    
    inline int dfs(int x){
        for(int j=1;j<=cnt;j++){
            if(!check[j] && link[x][j]){
                check[j]=1;
                if(match[j]==-1 || dfs(match[j])){
                    match[j]=x;
                    return 1;
                }
            }
        }
        return 0;
    }
    
    int main(){
        while(~scanf("%d",&n)){
            if(n==0) break ;
            init();
            getchar();
            for(int i=1;i<=n;i++){
                for(int j=1;j<=n;j++) scanf("%c",&tmp[i][j]);
                getchar();
            }
            int k;
            for(int i=1;i<=n;i++){
                for(int j=1;j<=n;j++){
                    if(tmp[i][j]=='.'){
                        tot++;
                        for(k=j;k<=n;k++){
                            j=k;
                            if(tmp[i][k]=='X') break ;
                            map1[i][k]=tot;
                        }
                    }
                }
            }
            for(int j=1;j<=n;j++){
                for(int i=1;i<=n;i++){
                    if(tmp[i][j]=='.'){
                        cnt++;
                        for(k=i;k<=n;k++){
                            i=k;
                            if(tmp[k][j]=='X') break;
                            map2[k][j]=cnt;
                        }
                    }
                }
            }
            for(int i=1;i<=n;i++){
                for(int j=1;j<=n;j++){
                    if(tmp[i][j]=='.') link[map1[i][j]][map2[i][j]]=1;
                }
            }
            for(int i=1;i<=tot;i++){
                memset(check,0,sizeof(check));
                if(dfs(i)) ans++;
            }
            printf("%d
    ",ans);
        }
        return 0;
    } 
    二分图匹配

    DFS的话就比较好想了,每放一个点,就判断一下这个点可不可以放,可以放的话做个标记,不能放就继续搜索。

    我一开始想的时行列作为状态,但发现这样不好进行判断,DFS有点混乱。

    最后发现一个一个格子进行搜索就行了,边界也比较明确,每次判断只用判断它的前面和上面。

    代码如下:

    #include <cstdio>
    #include <cstring>
    #include <iostream>
    #include <algorithm>
    using namespace std;
    
    const int N = 10 ;
    char map[N][N];
    int n,ans=0;
    
    inline void init(){
        getchar();ans=0;
    }
    
    inline bool judge(int x,int y){
        int flag1 = 1,flag2 = 1;
        for(int i=x-1;i>=1;i--){
            if(map[i][y]=='@'){
                flag1=0;break ;
            }
            if(map[i][y]=='X'){break ;}
        }
        for(int i=y-1;i>=1;i--){
            if(map[x][i]=='X'){break;}
            if(map[x][i]=='@'){
                flag2=0;break ;
            }
        }
        if(flag1 && flag2) return true;
        return false ;
    }
    
    inline void dfs(int k,int cnt){
        int x=k/n+1,y=k%n;
        if(y==0) y=n;
        if(k%n==0) x=k/n;
        if(k>n*n){
            ans=max(ans,cnt);
            return ;
        }
        if(map[x][y]=='X')dfs(k+1,cnt);
        if(map[x][y]=='.'){
            if(judge(x,y)){
                map[x][y]='@';
                dfs(k+1,cnt+1);
                map[x][y]='.';
                dfs(k+1,cnt);
            }else{
                dfs(k+1,cnt);
            }
        }
    }
    
    int main(){
        while(scanf("%d",&n)!=EOF){
            if(n==0) break;
            init();
            for(int i=1;i<=n;i++){
                for(int j=1;j<=n;j++) scanf("%c",&map[i][j]);
                getchar();
            }
            dfs(1,0);
            printf("%d
    ",ans);
        }
        return 0;
    }
    DFS

    重要的是自信,一旦有了自信,人就会赢得一切。

  • 相关阅读:
    java集合:ArrayList(1)
    java虚拟机:堆内存
    计算机三种编码与加减运算
    java虚拟机:程序计数器
    java虚拟机:JIT编译器
    java虚拟机:运行时常量池
    java虚拟机:方法区
    java虚拟机:本地方法栈
    java虚拟机:class文件结构
    linux安装mysql
  • 原文地址:https://www.cnblogs.com/heyuhhh/p/9914694.html
Copyright © 2020-2023  润新知